{varType Skadmin\Gallery\Doctrine\Gallery\Gallery[] $galleries}
{varType Skadmin\Gallery\Doctrine\Gallery\Gallery $currentGallery}
{varType SkadminUtils\Gallery\Factory\GallerySettingsFactory $gallerySettings}

<div class="row">
    <div class="col-12 mb-3">
        {include #renderBreadcrumb}
    </div>
</div>

<div class="row">
    <div class="col-12 mb-4">
        {include #renderGalleries}
    </div>
</div>

<div class="row" n:if="$currentGallery->isLoaded()">
    <div class="col-12 mb-4">
        {include #renderPhotos}
    </div>
</div>

<style>
    .ui-sortable-handle {
        transition: transform ease-in-out 250ms;
    }

    .ui-sortable-helper {
        transform: scale(0.90);
    }

    .ui-sortable-helper .js-gallery-btn {
        display: none !important;
    }

    .ui-state-highlight {
        background-color: transparent !important;
        border: none !important;
        min-height: 150px;
    }

    .ui-state-highlight div {
        background-color: rgba(51, 83, 113, 0.3);
        background-clip: border-box;
        border: 2px solid #335371;
        border-radius: 0.35rem;
        height: 100%;
    }
</style>

<script n:syntax="double">
    $(function () {
        $('.js-gallery-sorting')
            .sortable({
                placeholder: 'ui-state-highlight',
                items: '.js-gallery',
                handle: '.js-gallery-handle',
                cursorAt: {
                    top: 38,
                    left: 50
                },
                start: function (e, ui) {
                    $('.js-gallery-sorting .ui-state-highlight')
                        .html('<div></div>')
                        .addClass('col-12 col-sm-6 col-lg-4 col-xl-3 mb-4');
                },
                update: function (e, ui) {
                    let order = {};
                    let index = 1;
                    ui.item.closest('.js-gallery-sorting').find('.js-gallery').each(function () {
                        order[$(this).data('gallery-id')] = index++;
                    });

                    let url = {{link updateSequenceGallery! jsonOrder => 'jsonOrderParam'}};

                    $.nette.ajax({
                        url: url.replace('jsonOrderParam', JSON.stringify(order))
                    });
                }
            });

        $('.js-gallery-photo-sorting')
            .sortable({
                placeholder: 'ui-state-highlight',
                items: '.js-gallery-photo',
                handle: '.js-gallery-photo-handle',
                cursorAt: {
                    top: 38,
                    left: 50
                },
                start: function (e, ui) {
                    $('.js-gallery-photo-sorting .ui-state-highlight')
                        .html('<div></div>')
                        .addClass('col-12 col-sm-6 col-lg-4 col-xl-3 mb-4');
                },
                update: function (e, ui) {
                    let order = {};
                    let index = 1;
                    ui.item.closest('.js-gallery-photo-sorting').find('.js-gallery-photo').each(function () {
                        order[$(this).data('gallery-photo-id')] = index++;
                    });

                    let url = {{link updateSequencePhoto! jsonOrder => 'jsonOrderParam'}};

                    $.nette.ajax({
                        url: url.replace('jsonOrderParam', JSON.stringify(order))
                    });
                }
            });
    });
</script>

{define #renderBreadcrumb}
    <div class="card shadow">
        <div class="card-body d-flex justify-content-between">
            {var $control = new Skadmin\Gallery\BaseControl()}
            <div>
                <ol class="breadcrumb p-0 m-0 bg-transparent">
                    <li class="breadcrumb-item">
                        <a href="{plink Component:default, 'package' => (new Skadmin\Gallery\BaseControl()), render => 'overview-gallery'}">
                            <i class="fas fa-fw fa-home"></i>
                        </a>
                    </li>
                    {if $currentGallery->isLoaded()}
                        <li class="breadcrumb-item" n:foreach="array_reverse($currentGallery->getParentGalleries()) as $bcGallery">
                            <a href="{plink Component:default, 'package' => (new Skadmin\Gallery\BaseControl()), render => 'overview-gallery', id => $bcGallery->getId()}">
                                {$bcGallery->getName()}
                            </a>
                        </li>
                        <li class="breadcrumb-item active" aria-current="page">{$currentGallery->getName()}</li>
                    {else}
                        <li class="breadcrumb-item active" aria-current="page">{_'form.gallery.edit-gallery.current-gallery'}</li>
                    {/if}
                </ol>
            </div>

            <div n:if="$currentGallery->isLoaded()">
                <a href="{plink Component:default, 'package' => (new Skadmin\Gallery\BaseControl()), render => 'edit-gallery', id => $currentGallery->getId()}"
                   class="ajax no-hover">
                    <i class="fas fa-fw fa-pen"></i> <span class="d-none d-md-inline-block">{_'form.gallery.edit-gallery.edit-current'}</span>
                </a>
            </div>
        </div>
    </div>
{/}

{define #renderGalleries}
    <div class="card shadow">
        <div class="card-header">
            <span class="badge badge-primary" n:snippet="snipCountGalleries">{count($galleries)}</span> {_'form.gallery.edit-gallery.galleries'}
        </div>

        <div class="card-body pb-0">
            <div class="row js-gallery-sorting" n:snippet="snipGalleries">

                <div class="col-12 col-sm-6 col-lg-4 col-xl-3 mb-3">
                    <a href="{plink Component:default, 'package' => (new Skadmin\Gallery\BaseControl()), render => 'edit-gallery', galleryId => $currentGallery->getId()}"
                       class="card no-hover ajax h-100">
                        <div class="card-body d-flex align-items-center justify-content-center">
                            <i class="fas fa-fw fa-4x fa-plus"></i>
                        </div>
                    </a>
                </div>

                <div class="col-12 col-sm-6 col-lg-4 col-xl-3 mb-3 js-gallery" data-gallery-id="{$gallery->getId()}" n:foreach="$galleries as $gallery">
                    <div class="card card-gallery">
                        <img n:img="$gallery->getImagePreview(), '485x350', 'exact'" class="card-img-top" alt="{$gallery->getName()}">

                        <div class="card-header d-flex justify-content-start">
                            <span class="btn btn-xs btn-light py-1 mr-1 js-gallery-handle">
                                <i class="fas fa-fw fa-arrows-alt"></i>
                            </span>

                            <a href="{plink Component:default, 'package' => (new Skadmin\Gallery\BaseControl()), render => 'overview-gallery', id => $gallery->getId()}"
                               class="btn btn-xs btn-primary py-1 js-gallery-btn">
                                <i class="far fa-fw fa-folder-open"></i>
                            </a>

                            <span data-link="{link removeGallery! id => $gallery->getId()}"
                                  data-confirm="{(new Skadmin\Translator\SimpleTranslation('form.gallery.edit-gallery.remove-gallery - %s', $gallery->getName()))|translate}"
                                  class="btn btn-xs btn-danger py-1 ml-auto mr-1 js-gallery-btn ajax">
                                <i class="fas fa-fw fa-trash"></i>
                            </span>

                            <a href="{plink Component:default, 'package' => (new Skadmin\Gallery\BaseControl()), 'render' => 'edit-gallery', 'id' => $gallery->getId()}"
                               class="btn btn-xs btn-primary py-1 mr-1 js-gallery-btn ajax">
                                <i class="fas fa-fw fa-pen"></i>
                            </a>

                            {if $gallery->getContent()}
                                <span class="btn btn-xs btn-warning py-1 js-gallery-btn shadow d-none d-sm-inline-block"
                                      title="{$gallery->getName()}"
                                      data-toggle="popover"
                                      data-content="{$gallery->getContent()|stripHtml}"
                                      data-trigger="hover">
                                        <i class="fas fa-fw fa-info"></i>
                                    </span>
                            {else}
                                <span class="btn btn-xs btn-warning py-1 js-gallery-btn shadow d-none d-sm-inline-block"
                                      data-toggle="popover"
                                      data-content="{$gallery->getName()}"
                                      data-trigger="hover">
                                        <i class="fas fa-fw fa-info"></i>
                                    </span>
                            {/}
                        </div>

                        <div class="card-footer d-flex justify-content-between align-items-center">
                            <span>{$gallery->getName()|truncate:30}</span>
                            <i class="fas fa-fw fa-circle text-{$gallery->isActive() ? success : danger}"></i>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
{/}

{define #renderPhotos}
    <div class="card shadow">
        <div class="card-header" n:snippet="snipCountPhotos">
            <span class="badge badge-primary">{$currentGallery->getPhotos()->count()}</span> {_'form.gallery.edit-gallery.photos'}
        </div>

        <div class="card-body pb-0">

            <div class="row gallery-video-input" n:if="$gallerySettings->isAllowVideo()">
                <div class="col-12">
                    <div class="input-group">
                        <input type="text" class="form-control js-gallery-video" placeholder="{_'form.gallery.edit-gallery.video-add.placeholder'}">
                        <div class="input-group-append">
                            <span class="btn btn-outline-primary js-gallery-video-add">{_'form.gallery.edit-gallery.video-add'}</span>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row mb-3">
                <div class="col-12">
                    {control formDropzone}
                </div>
            </div>

            <div class="row js-gallery-photo-sorting" n:snippet="snipPhotos">

                <div class="col-12 col-sm-6 col-lg-4 col-xl-3 mb-3 js-gallery-photo" data-gallery-photo-id="{$photo->getId()}" n:foreach="$currentGallery->getPhotos() as $photo">
                    <div class="card card-gallery">
                        <img n:img="$photo->getImagePreview(), '485x485', 'exact'" class="card-img-top" alt="{$photo->getName()}">

                        <div class="card-header d-flex justify-content-start">
                            <span class="btn btn-xs btn-light py-1 mr-1 js-gallery-photo-handle">
                                <i class="fas fa-fw fa-arrows-alt"></i>
                            </span>

                            <span data-link="{link removePhoto! id => $photo->getId()}"
                                  data-confirm="{(new Skadmin\Translator\SimpleTranslation('form.gallery.edit-gallery.remove-photo - %s', $photo->getName()))|translate}"
                                  class="btn btn-xs btn-danger py-1 ml-auto mr-1 js-gallery-btn ajax">
                                <i class="fas fa-fw fa-trash"></i>
                            </span>

                            <a href="{plink Component:default, 'package' => (new Skadmin\Gallery\BaseControl()), 'render' => 'edit-photo', 'id' => $photo->getId()}"
                               class="btn btn-xs btn-primary py-1 mr-1 js-gallery-btn ajax">
                                <i class="fas fa-fw fa-pen"></i>
                            </a>

                            {if $photo->getTitle(true)}
                                <span class="btn btn-xs btn-warning py-1 js-gallery-btn shadow d-none d-sm-inline-block"
                                      title="{$photo->getName()}"
                                      data-toggle="popover"
                                      data-content="{$photo->getTitle(true)|stripHtml}"
                                      data-trigger="hover">
                                        <i class="fas fa-fw fa-info"></i>
                                    </span>
                            {else}
                                <span class="btn btn-xs btn-warning py-1 js-gallery-btn shadow d-none d-sm-inline-block"
                                      data-toggle="popover"
                                      data-content="{$photo->getName()}"
                                      data-trigger="hover">
                                        <i class="fas fa-fw fa-info"></i>
                                    </span>
                            {/}
                        </div>

                        <div class="card-footer d-flex justify-content-between align-items-center">
                            <span>{$photo->getName()|truncate:30}</span>
                            <div>
                                <i class="fas fa-fw fa-{$photo->isVideo() ? 'video' : 'image'} text-{$photo->isActive() ? success : danger}"></i>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>

    <style n:if="$gallerySettings->isAllowVideo()">
        .gallery-video-input input {
            border: 2px dashed #335371;
            border-bottom-left-radius: 0;
            border-bottom: none;
        }

        .gallery-video-input span {
            border: 2px dashed #335371;
            border-bottom-right-radius: 0;
            border-bottom: none;
            border-left: none;
        }

        .gallery-video-input + .row form {
            border-top-left-radius: 0;
            border-top-right-radius: 0;
        }
    </style>

    <script n:syntax="double" n:if="$gallerySettings->isAllowVideo()">
        $(function () {
            $(document).on('click', '.js-gallery-video-add', function () {
                if ($('.js-gallery-video').val()) {
                    var data = {};
                    data[{{$control->getParameterId('video')}}] = $('.js-gallery-video').val();

                    $.nette.ajax({
                        url: {{link addVideo!}},
                        data: data,
                        success: function (data) {
                            $('.js-gallery-video').val('');
                        }
                    });
                }
            });
        });
    </script>
{/}